//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL4ST7 (with ST7FLI49M)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD character display (HD44780 compatible) in 4-bit mode.
//
//    Settings and connections on ZL4ST7:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PB4 (con16)
//        D5 (LCD_CHAR/con13) - PB5 (con16)
//        D6 (LCD_CHAR/con13) - PB6 (con16)
//        D7 (LCD_CHAR/con13) - PB7 (con16)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con16)
//
//
//******************************************************************************
#include <ST7LITE4.H> 
#include "HD44780.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char temp;
int i;
LCD_Initialize();

LCD_GoTo(0,0);
LCD_WriteText(" -- ZL4ST7 -- ZL4ST7 --");
LCD_GoTo(0,1);
LCD_WriteText(" Kamami Development Board");

do{
for(temp = 0; temp < 10; temp++) // shift the text to the left
  {
  LCD_ShiftLeft();
  for(i = 0; i < 0x7FFF; i++);
  }
for(temp = 0; temp < 10; temp++) // shift the text to the right 
  {
  LCD_ShiftRight();
  for(i = 0; i < 0x7FFF; i++);
  }
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
