//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : GRAPH_LCD
// BOARD    : ZL4ST7 (with ST7FLI49M)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD graphic display (KS0108 compatible)
//
//    Settings and connections on ZL4ST7:
//        JP4 (DISPLAY) - 1-2 (=GRAPH)
//
//        D0 (LCD_GRAPH/con12) - PB0 (con16)
//        D1 (LCD_GRAPH/con12) - PB1 (con16)
//        D2 (LCD_GRAPH/con12) - PB2 (con16)
//        D3 (LCD_GRAPH/con12) - PB3 (con16)
//        D4 (LCD_GRAPH/con12) - PB4 (con16)
//        D5 (LCD_GRAPH/con12) - PB5 (con16)
//        D6 (LCD_GRAPH/con12) - PB6 (con16)
//        D7 (LCD_GRAPH/con12) - PB7 (con16)
//
//        RS (LCD_GRAPH/con12) - PC0 (con17)
//        RW (LCD_GRAPH/con12) - PC1 (con17)
//        E  (LCD_GRAPH/con12) - PC4 (con17)
// If CSx is active low :
//        CS1(LCD_GRAPH/con12) - PC5 (con17)
//        CS2(LCD_GRAPH/con12) - PC6 (con17)
// If CSx is active high:
//        CS1(LCD_GRAPH/con12) - PC6 (con17)
//        CS2(LCD_GRAPH/con12) - PC5 (con17)
//
//******************************************************************************
#include "KS0108.h"
#include "kamami.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
volatile unsigned int i,j;

GLCD_Initialize();  							// LCD initialization

do{
GLCD_ClearScreen(); 							// clear screen

GLCD_WriteStringXY("   K A M A M I",12,0);		//
GLCD_WriteStringXY("development board",12,1);	// display text
GLCD_WriteStringXY("  -- ZL4ST7 --  ",12,3);	//
GLCD_WriteStringXY(" www.kamami.com ",12,4);	//

for(i = 0; i < 0xFFFF; i++)
  for(j = 0; j < 0x20; j++);

GLCD_Bitmap((char *)kamami, 0, 0, 128 , 64);	// display picture

for(i = 0; i < 0xFFFF; i++)						
  for(j = 0; j < 0x20; j++);

  }while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
