//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RC5
// BOARD    : ZL4ST7 (with ST7FLI49M)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple infrared RC5 code receiver.
//    Received code is displayed on LCD.
//
//    Settings and connections on ZL4ST7:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        IR (con7) - PC0 (con17)
//
//        D4 (LCD_CHAR/con13) - PB4 (con16)
//        D5 (LCD_CHAR/con13) - PB5 (con16)
//        D6 (LCD_CHAR/con13) - PB6 (con16)
//        D7 (LCD_CHAR/con13) - PB7 (con16)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con16)
//
//******************************************************************************
#include <ST7LITE4.H>

#include "HD44780.h"
#include "RC5.h"

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char str [5];
char RC5Address=0, RC5Command=0;

PADDR = 1;
PAOR = 1;

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText("Waiting for RC5...\r");

RC5_Init();

do{
  LCD_GoTo(0,1);
  GetRC5(&RC5Address, &RC5Command);
  LCD_WriteText("Adr: ");
  LCD_WriteText(Hex(RC5Address, str));
  LCD_WriteText(" Cmd: ");
  LCD_WriteText(Hex(RC5Command, str));
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
