//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include <ST7LITE4.H>
#include <intrist7.h>

volatile unsigned char Cmd, CmdN, Adr, AdrN;
volatile unsigned char RC5Counter, RC5Status;

#define RC5PIN PCDR
#define RC5IN  (1 << 0)
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void GetRC5(char * Address, char * Command)
{
Cmd = CmdN = Adr = AdrN = 0;
RC5Counter = RC5Status = 0;
while(RC5PIN & RC5IN);
ATCSR = 0x12;
do{
if(RC5Status & 0x80)
    {
    Cmd = CmdN = Adr = AdrN = 0;
    RC5Counter = RC5Status = 0;
    ATCSR = 0x12;
    }
}while((RC5Status & 1)==0);
*Address = Adr;
*Command = Cmd;
return;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void RC5_Init(void)
{
Cmd = CmdN = Adr = AdrN = 0;
RC5Counter = RC5Status = 0;

ATR1L = 0b00100000;
ATR1H = 0b00000010;

_rim_();
return;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
void TimerInt(void) interrupt 7
{
volatile unsigned char  something;
something = ATCSR;

RC5Counter++;

PADR ^= 1;

if(RC5Counter < 7)
  return;
else
if((RC5Counter >=7) && (RC5Counter < 30))
  {
  if((RC5Counter==9)||(RC5Counter==13)||(RC5Counter==17)||(RC5Counter==21)||(RC5Counter==25)||(RC5Counter==29))
    {
    Adr <<= 1;
    if(!(RC5PIN & RC5IN))
      Adr |= 1;
    }
  else
  if((RC5Counter==7)||(RC5Counter==11)||(RC5Counter==15)||(RC5Counter==19)||(RC5Counter==23)||(RC5Counter==27))
    {
    AdrN <<= 1;
    if(RC5PIN & RC5IN)
      AdrN |= 1;
    }
  }
else
if((RC5Counter < 56)&&(RC5Counter >= 30))
  {
  if((RC5Counter==33)||(RC5Counter==37)||(RC5Counter==41)||(RC5Counter==45)||(RC5Counter==49)||(RC5Counter==53))
    {
    Cmd <<= 1;
    if(!(RC5PIN & RC5IN))
      Cmd |= 1;
    }
  else
  if((RC5Counter==31)||(RC5Counter==35)||(RC5Counter==39)||(RC5Counter==43)||(RC5Counter==47)||(RC5Counter==51))
    {
    CmdN <<= 1;
    if(RC5PIN & RC5IN)
      CmdN |= 1;
    }
  }
else
if(RC5Counter >= 57)
  {
  ATCSR = 0;
  RC5Counter = 0;
  if(Cmd != CmdN)
    {
    RC5Status |= 0x80;
    return;
    }
  if(Adr != AdrN)
    {
    RC5Status |= 0x80;
    return;
    }
  Adr &= 0x1F;
  Cmd &= 0x3F;
  RC5Status |= 1;
  }
return;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
