//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RTC
// BOARD    : ZL4ST7 (with ST7FLI49M)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read time from RTC (U6 - M41T00)
//    and display it on LCD.
//
//    Settings and connections on ZL4ST7:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        SCL (U6 RTC/con7) - PA7 (con15)
//        SDA (U6 RTC/con7) - PA6 (con15)
//
//        D4 (LCD_CHAR/con13) - PB4 (con16)
//        D5 (LCD_CHAR/con13) - PB5 (con16)
//        D6 (LCD_CHAR/con13) - PB6 (con16)
//        D7 (LCD_CHAR/con13) - PB7 (con16)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con16)
//
//******************************************************************************
#include <ST7LITE4.H>
#include "HD44780.h"
#include "TWI.h"
//-------------------------------------
// main program
//-------------------------------------
void main(void)
{
char B1;
volatile unsigned int i;

LCD_Initialize();
TWI_Init();

do{
LCD_GoTo(0,0);
LCD_WriteText("M41T00\r");
LCD_GoTo(0,1);
TWI_Start();                        // start transmission
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x02);                    // select hours register
TWI_Start();                        // repeated start
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read hours register
TWI_Stop();                         // stop transmission    

LCD_WriteData(((B1>>4)&3)+'0');     // convert hours to ASCII char
LCD_WriteData((B1&15)+'0');         // convert hours to ASCII char
LCD_WriteData(':');                         

TWI_Start();                        // start transmission  
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x01);                    // select minutes register  
TWI_Start();                        // repeated start
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read minutes register
TWI_Stop();                         // stop transmission

LCD_WriteData(((B1>>4)&7)+'0');     // convert minutes to ASCII char
LCD_WriteData((B1&15)+'0');         // convert minutes to ASCII char
LCD_WriteData(':');

TWI_Start();                        // start transmission
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x00);                    // select seconds register
TWI_Start();                        // repeated start         
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read minutes register
TWI_Stop();                         // stop transmission

LCD_WriteData(((B1>>4)&7)+'0');     // convert seconds to ASCII char
LCD_WriteData((B1&15)+'0');         // convert seconds to ASCII char

for(i = 0; i < 0xFFFF; i++);

}while(1);
}
//-------------------------------------
// End of file
//-------------------------------------
