//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : TEMP_STCN75
// BOARD    : ZL4ST7 (with ST7FLI49M)
// COMPILER : RKitSTM8 for Ride7
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read temperature from U7 (STCN75)
//    and display it on LCD.
//
//    Settings and connections on ZL4ST7:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        SCK (U7 TEM/con8) - PA7 (con15)
//        SDA (U7 TEM/con8) - PA6 (con15)
//        A0  (U7 TEM/con8) - GND (con15)
//
//        D4 (LCD_CHAR/con13) - PB4 (con16)
//        D5 (LCD_CHAR/con13) - PB5 (con16)
//        D6 (LCD_CHAR/con13) - PB6 (con16)
//        D7 (LCD_CHAR/con13) - PB7 (con16)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con16)
//
//******************************************************************************
#include "TWI.h"
#include "HD44780.h"
//-------------------------------------
// main program
//-------------------------------------
void main(void)
{
volatile unsigned int i;
unsigned char t1,t2;
int temp;
char mod;

LCD_Initialize();
TWI_Init();
do{
    TWI_Start();            // start
    TWI_Write(0x90);        // STCN75 write address
    TWI_Write(0x00);        // pointer
    TWI_Start();            // start
    TWI_Write(0x91);        // STCN75 read address
    t1 = TWI_Read(ACK);     // read MSB
    t2 = TWI_Read(NACK);    // read LSB
    TWI_Stop();             // stop

    temp = (t1 << 1);
    temp |= (t2 >> 7);

    LCD_GoTo(0,0);              // First line
    LCD_WriteText("STCN75:");   // display text

    mod = (temp % 2) ?  5 : 0 ; // 
    temp = temp / 2;            // convert to celsius
    
    LCD_GoTo(0,1);                  // second line
    LCD_WriteData((temp/10)+'0');   //
    LCD_WriteData((temp%10)+'0');   // display temperature
    LCD_WriteData('.'); 
    LCD_WriteData(mod+'0');
    LCD_WriteData('C');

    for(i = 0 ; i < 0x3FF; i++);    // wait
}while(1);
}
//-------------------------------------
// End of file
//-------------------------------------